package com.hai.schedule;

import com.hai.common.utils.ResponseMsgUtil;
import com.hai.entity.HighUserCoupon;
import com.hai.service.HighUserCouponService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.Scheduled;

import javax.annotation.Resource;
import java.util.List;

/**
 * @Auther: 胡锐
 * @Description: 卡卷定时任务
 * @Date: 2021/3/27 15:39
 */
@Configuration
public class HighCouponSchedule {

    private static Logger log = LoggerFactory.getLogger(HighCouponSchedule.class);

    @Resource
    private HighUserCouponService highUserCouponService;

    /**
     * @Author 胡锐
     * @Description 处理过期的卡券
     * @Date 2021/4/4 22:44
     **/
    @Scheduled(cron = "5 0 0 * * ?")   //每日凌晨12点5秒执行一次
    public void expiredCoupon() {
        // 查询过期的卡券
        List<HighUserCoupon> userCoupons = highUserCouponService.getOverdueCoupon();
        for (HighUserCoupon userCoupon : userCoupons) {
            try {
                highUserCouponService.expiredCoupon(userCoupon.getId());
            } catch (Exception e) {
                log.error("HighCouponSchedule --> expiredCoupon() error!", e);
            }
        }
    }
}
